{
   muu TrueColor library for TMT Pascal - Console ancestor object
   Copyright (C) 1999 Tor Arne Gustad (anden@online.no)

   This source code is licensed under the GNU Public License.
   See the GNU General Public License for more details.
}

UNIT mConsole;

    // choose config file language
{$DEFINE console_option_english}

INTERFACE
{$R-,I+,Q-}

USES mArea,mFormat,mSurface,STRINGS;

    // default option file
CONST mtc_option_file = '.\mtc.cfg';

{$IFDEF console_option_english}
  {$I include\options.en}
{$ENDIF}

TYPE ConsoleInfo =  RECORD
                      Width:    word;
                      Height:   word;
                      Format:   Format;
                      Name:     pchar;
                      Area:     Area;
                    END;

    // Console object (dynamic)
// --------------------------------------------------------------------------
TYPE Console =  ^ConsoleT;
     ConsoleT = OBJECT

                 public
                    // Console object creation
                  CONSTRUCTOR Create;
                  DESTRUCTOR Destroy; VIRTUAL;

                    // Option interface
                  PROCEDURE Option(optv:pchar); VIRTUAL;

                    // Initialization
                  PROCEDURE Open(m_title:pchar;m_width,m_height:word;m_format:Format); VIRTUAL;
                  PROCEDURE Close; VIRTUAL;

                    // Error interface
                  FUNCTION Error:   boolean; VIRTUAL;

                    // Screen manipulation
                  PROCEDURE Copy(tx,ty:longint;m_surface:Surface;m_area:Area); VIRTUAL;
                  PROCEDURE Clear(m_area:Area;m_color:dword); VIRTUAL;
                  PROCEDURE Stretch(m_source:Area;m_surface:Surface;m_dest:Area); VIRTUAL;

                    // Update screen
                  PROCEDURE Update; VIRTUAL;

                    // Console information
                  FUNCTION Info:    ConsoleInfo; VIRTUAL;

                    // Special features
                  PROCEDURE Wrap(wrap_console:Console); VIRTUAL;

                    // common procedures, not for overloading
                  PROCEDURE getOptions(m_optfile:string);

                    // message writer
                  PROCEDURE Message(m_string:string); VIRTUAL;
                END;

IMPLEMENTATION

FUNCTION console_msg(m_level:byte): string;
BEGIN

END;


// the Console object
// --------------------------------------------------------------------------
CONSTRUCTOR ConsoleT.Create;
BEGIN
    // check hardware, allocate memory
END;

DESTRUCTOR ConsoleT.Destroy;
BEGIN
    // free memory, reset hardware
END;

PROCEDURE ConsoleT.Option;
BEGIN
    // execute option (enable/disable hardware etc..)
END;

PROCEDURE ConsoleT.Open;
BEGIN
    // set mode, enable screen output
END;

PROCEDURE ConsoleT.Close;
BEGIN
    // disable screen output
END;

FUNCTION ConsoleT.Error;
    // report Console status
  result := false;

PROCEDURE ConsoleT.Copy;
BEGIN
    // copy Surface to screen
END;

PROCEDURE ConsoleT.Clear;
BEGIN
    // clear whole screen
END;

PROCEDURE ConsoleT.Stretch;
BEGIN
    // stretch Surface area to area on Console
END;

PROCEDURE ConsoleT.Update;
BEGIN
    // show the Console contents on the screen
END;

PROCEDURE ConsoleT.Wrap;
BEGIN
    // wrap console, useful for debugging purposes
END;

FUNCTION ConsoleT.Info;
BEGIN
    // return information about the Console
END;

PROCEDURE ConsoleT.getOptions;
  VAR f:    text;
      s:    string;
      o:    pchar;
      c:    integer;

BEGIN
  assign(f,m_optfile);
  {$I-} reset(f); {$I+}
  IF (IOResult <> 0) THEN
    Exit;
  getmem(o,1024);
  WHILE NOT eof(f) DO
  BEGIN
    readln(f,s);
    strPCopy(o,s);

        // skip comments and blank lines
    IF ((o[0] <> console_option_comment) AND (strlen(o) > 0)) THEN
      self.Option(o);
  END;
  freemem(o,1024);
  system.close(f);
END;

FUNCTION ConsoleT.Message;
BEGIN
    // display message in some way
END;


end.
