{
   muu Library for TMT Pascal - Error handling unit
   Copyright (C) 1999 Tor Arne Gustad (anden@online.no)

   This source code is licensed under the GNU Public License.
   See the GNU General Public License for more details.
}

UNIT Error;

INTERFACE
{$R-,I+,Q-}

USES ERRCODES;

// --------------------------------------------------------------------------
TYPE ErrorHandler = PROCEDURE(m_error:string);

    // set error handler
PROCEDURE sethandler(m_handler:ErrorHandler);

    // error
PROCEDURE fail(m_error:string);

// --------------------------------------------------------------------------
IMPLEMENTATION

PROCEDURE int_errh(m_error:string);
BEGIN
  ASM
    mov ah, $0F
    int $10

    cmp al, $03
    je  @@nosetmode

    mov ax, $03
    int $10

  @@nosetmode:
  END;

  writeln(m_error);
  Halt;
END;

VAR old_exitproc:   pointer := NIL;
    old_exitprocR:  PROCEDURE ABSOLUTE old_exitproc;
    call_handler:   ErrorHandler := NIL;

PROCEDURE fail;
  call_handler(m_error);

PROCEDURE sethandler;
  call_handler := m_handler;

// --------------------------------------------------------------------------
PROCEDURE new_exitproc;
BEGIN
  exitproc := old_exitproc;
  old_exitprocR;
END;

PROCEDURE runtime_error(exitcode,r_ebp,r_eip:dword);
  fail('runtime error: '+error_msg(exitcode));

// --------------------------------------------------------------------------
begin
    // change exit procedure
  old_exitproc := exitproc;
  exitproc := @new_exitproc;

    // change run-time error procedure
 {$SYSTEM}
  SYSTEM.%RUNERR_CALL_STACK_PROC_ADDR := @runtime_error;

    // set default error handler
  sethandler(int_errh);
end.
